package org.yangliu.codegenerate.util;

import freemarker.cache.ClassTemplateLoader;
import freemarker.core.XMLOutputFormat;
import freemarker.template.Configuration;
import freemarker.template.Template;
import freemarker.template.TemplateException;
import org.apache.commons.lang.StringUtils;
import org.yangliu.codegenerate.Main;

import java.io.File;
import java.io.FileWriter;
import java.io.IOException;
import java.util.Map;

/**
 * @Description
 * @Author ZhouWenTao
 * @Date 2023/8/13 21:04
 */
public class MarkerGenerate {
    public static void generate(String basePackagePath,String templateName,String parsePath,String fileName,Map<String,Object> dataMap) {
        String entityName = (String) dataMap.get("entityName");
        if (StringUtils.isNotBlank(entityName)) {
            dataMap.put("uncap_first",StringUtils.uncapitalize(entityName));//实体类首字母缩写参数
        }

        // 创建生成文件所在目录
        folderCreate(parsePath);

        //第一步：创建一个 Configuration 对象，直接 new 一个对象。构造方法的参数就是 freemarker的版本号。
        Configuration configuration = new Configuration(Configuration.getVersion());
        //第二步：设置模板文件所在的路径。
        configuration.setTemplateLoader(new ClassTemplateLoader(Main.class,basePackagePath));
        //第三步：设置模板文件使用的字符集。一般就是 utf-8.
        configuration.setDefaultEncoding("UTF-8");
        configuration.setOutputFormat(XMLOutputFormat.INSTANCE);
        //第四步：加载一个模板，创建一个模板对象。
        Template template = null;
        try {
            template = configuration.getTemplate(templateName);
        } catch (IOException e) {
            e.printStackTrace();
        }
        String outPut=parsePath+fileName;
        FileWriter fileWriter = null;
        try {
            fileWriter = new FileWriter(outPut);
            //    第七步：调用模板对象的 process 方法输出文件。
            template.process(dataMap,fileWriter);
            //    第八步：关闭流
            fileWriter.close();
        } catch (IOException e) {
            e.printStackTrace();
        } catch (TemplateException e) {
            e.printStackTrace();
        }
    }


    public static void folderCreate(String folder){
        if (StringUtils.isNotBlank(folder)) {
            File file =new File(folder);
            if (file.exists()) {
                if (file.isDirectory()) {/*System.out.println("dir exists");*/}
                else {
                    System.out.println("the same name file exists, can not create dir");
                }
            } else {
                //System.out.println("目录不存在，创建");
                file.mkdirs();
            }
        }
    }
}
