package org.yangliu.codegenerate.util;

import com.google.common.base.CaseFormat;
import org.yangliu.codegenerate.util.fieldType.DbColumnType;
import org.yangliu.codegenerate.util.fieldType.MySqlTypeConvert;
import org.yangliu.codegenerate.util.fieldType.PostgreSqlTypeConvert;

import java.util.Arrays;
import java.util.List;

/**
 * @Description
 * @Author ZhouWenTao
 * @Date 2023/8/13 21:54
 */
public class TableFieldUtil {
    private static List<String> strArray= Arrays.asList("char","varchar","text","xml");


    private static List<String> integerArray= Arrays.asList("int","int2","int4","int8","text","xml");

    /**
     * 将 数据库字段类型转成 java类型
     * @param fieldType
     * @return
     */
    public static String fieldTypeParseJava(String databaseType,String fieldType){
        if (databaseType.equals("mysql")) {
            DbColumnType dbColumnType = MySqlTypeConvert.processTypeConvert(fieldType);
            return dbColumnType.getType();
        }else if(databaseType.equals("postgresql")){
            DbColumnType dbColumnType = PostgreSqlTypeConvert.processTypeConvert(fieldType);
            return dbColumnType.getType();
        }
        System.out.println("暂不支持该数据库");
        return null;
    }


    public static String tableNameToEntityName(String tableName){
        String to = CaseFormat.LOWER_UNDERSCORE.to(CaseFormat.LOWER_CAMEL, tableName);
        String orderColumn = CaseFormat.LOWER_CAMEL.to(CaseFormat.UPPER_CAMEL,to);
        return orderColumn;
    }


    public static void main(String[] args) {
        String[] fields=new String[]{"id","pn_code","box_num","basic_unit","batch_num","status","warehouse_type","in_warehouse_time","responsible_user_id","factory_code","location_code","dn","stock_type","start_time","end_time"};
        String[] fieldNames=new String[]{"主键id","产品编码","箱数","基本计量单位","批次数量","检验单状态","仓库流转类型","入库时间","责任人id","厂区编码","库位编码","DN","库存类型","检验开始时间","检验结束时间"};
        for (int i = 0; i < fields.length; i++) {
            String s = CaseFormat.LOWER_UNDERSCORE.to(CaseFormat.LOWER_CAMEL, fields[i]);
            String fieldName = fieldNames[i];
            System.out.println(s+":"+fieldName);
        }

    }
}
